﻿using System;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;
//using System.Runtime.CompilerServices;
//using System.Security.Permissions;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;

public class YellowbloodSyringe : SyringeBehaviour
{
public override string GetLiquidID() => Yellowblood.ID;

public class Yellowblood : Liquid
{
public Yellowblood()
{
this.Color = new Color32(255, 234, 0, 200);
}

public const string ID = "YELLOWBLOOD";

public override void OnEnterLimb(LimbBehaviour limb)
{
limb.Person.PainLevel*= 0f;
limb.Person.ShockLevel *= 0f;
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
circ.Limb.Person.PainLevel*= 0f;
circ.Limb.Person.ShockLevel *= 0f;
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class YellowbloodSyringe1 : SyringeBehaviour
{
public override string GetLiquidID() => YellowbloodSyringe.ID;

public class YellowbloodSyringe : Liquid
{
public YellowbloodSyringe()
{
this.Color = new Color32(255, 234, 0, 200);
}

public const string ID = "YELLOWBLOODSYRINGE";

public override void OnEnterLimb(LimbBehaviour limb)
{
limb.BloodLiquidType = "YELLOWBLOOD";
if (limb.gameObject.GetComponent<ImprovingBehaviour>() == null)
{
limb.ImpactPainMultiplier *= 0f;
limb.gameObject.AddComponent<ImprovingBehaviour>();
limb.GetComponent<CirculationBehaviour>().BloodRegenerationPerSecond *= 3f;
limb.Health *= 3f;
limb.RegenerationSpeed *= 3f;
limb.InitialHealth *= 3f;
limb.ShotDamageMultiplier *= 0.9f;
limb.BreakingThreshold *= 3f;
limb.ImpactPainMultiplier *= 0.3f;
limb.Numbness *= 10f;
limb.CirculationBehaviour.BloodFlow *= 1.8f;
limb.GetComponent<CirculationBehaviour>().AddLiquid(limb.GetOriginalBloodType(), 1.4f);
}
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class RegenerationSyringe1 : SyringeBehaviour
{
public override string GetLiquidID() => RegenerationSyringe.ID;

public class RegenerationSyringe : Liquid
{
public RegenerationSyringe()
{
this.Color = new Color32(127, 0, 0, 200);
}

public const string ID = "REGENERATIONSYRINGE";

public override void OnEnterLimb(LimbBehaviour limb)
{
if (limb.gameObject.GetComponent<RGB>() == null)
{
limb.gameObject.AddComponent<RGB>();
}
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class MagSyringe1 : SyringeBehaviour
{
public override string GetLiquidID() => MagSyringe.ID;

public class MagSyringe : Liquid
{
public MagSyringe()
{
this.Color = new Color32(127, 0, 0, 200);
}

public const string ID = "MAGSYRINGE";

public override void OnEnterLimb(LimbBehaviour limb)
{
limb.GetComponent<CirculationBehaviour>().BloodRegenerationPerSecond = 1f;
limb.RegenerationSpeed = 900f;
limb.InitialHealth = 70000f;
limb.ShotDamageMultiplier = 0.9f;
limb.BreakingThreshold = 100f;
limb.ImpactPainMultiplier = 0.3f;
//limb.Numbness *= 10f;
limb.CirculationBehaviour.BloodFlow = 100f;
limb.gameObject.AddComponent<MagheightBeh>();
limb.IsZombie = true;
limb.SkinMaterialHandler.ShouldRot = false;
limb.HasBrain = false;
limb.Health = 70000f;
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class Go3lmSyringe1 : SyringeBehaviour
{
public override string GetLiquidID() => Go3lmSyringe.ID;

public class Go3lmSyringe : Liquid
{
public Go3lmSyringe()
{
this.Color = new Color32(127, 0, 0, 200);
}

public const string ID = "GO3LMSYRINGE";

public override void OnEnterLimb(LimbBehaviour limb)
{
limb.GetComponent<CirculationBehaviour>().BloodRegenerationPerSecond *= 3f;
limb.Health = 4000f;
limb.RegenerationSpeed = 300f;
limb.InitialHealth = 4000f;
limb.ShotDamageMultiplier = 0.9f;
limb.BreakingThreshold = 15f;
limb.ImpactPainMultiplier = 0.3f;
//limb.Numbness *= 10f;
limb.CirculationBehaviour.BloodFlow = 10f;
limb.gameObject.AddComponent<G03LMgheightBeh>();
limb.IsZombie = true;
limb.SkinMaterialHandler.ShouldRot = false;
//limb.HasBrain = false;
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class ShitManagerSyringe1 : SyringeBehaviour
{
public override string GetLiquidID() => Enchance.ID;

public class Enchance : Liquid
{
public Enchance()
{
this.Color = new Color32(127, 123, 22, 140);
}

public const string ID = "ENchance";

public override void OnEnterLimb(LimbBehaviour limb)
{
if (limb.gameObject.GetComponent<ShitManager>() == null)
{
limb.gameObject.AddComponent<ShitManager>();
if (limb.gameObject.GetComponent<ImmortalityBehaviour1>() == null)
{
limb.gameObject.AddComponent<ImmortalityBehaviour1>();
}
limb.GetComponent<CirculationBehaviour>().BloodRegenerationPerSecond = 1f;
limb.RegenerationSpeed = 900f;
limb.InitialHealth = 70000f;
limb.ShotDamageMultiplier = 0.9f;
limb.BreakingThreshold = 100f;
limb.ImpactPainMultiplier = 0.3f;
//limb.Numbness *= 10f;
limb.CirculationBehaviour.BloodFlow = 100f;
limb.IsZombie = true;
limb.SkinMaterialHandler.ShouldRot = false;
limb.Health = 70000f;
limb.Person.Braindead = false;
limb.Person.BrainDamaged = false;
}
}
public override void OnUpdate(BloodContainer container)
{
if (container is CirculationBehaviour circ && circ.Limb.SpeciesIdentity != Species.Android)
{
}
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
}
}

public class ClearAllSyringe : SyringeBehaviour
{
public override string GetLiquidID() => ClearLiquid.ID;

public class ClearLiquid : Liquid 
{
public const string ID = "CLEARLIQUID";

public ClearLiquid()
{
this.Color = new Color32(200, 200, 200, 0);
}
public override void OnEnterLimb(LimbBehaviour limb)
{
if (limb.GetComponent<ClearnBeh>() == null)
{
limb.gameObject.AddComponent<ClearnBeh>();
}
}
public override void OnUpdate(BloodContainer container)
{
}
public override void OnEnterContainer(BloodContainer container)
{
}
public override void OnExitContainer(BloodContainer container)
{
}
 }
 }